﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using GridDataBindMVCCore.Models;

namespace GridDataBindMVCCore.Controllers
{
    public class HomeController : Controller
    {
        private readonly ILogger<HomeController> _logger;

        public HomeController(ILogger<HomeController> logger)
        {
            _logger = logger;
        }

        public IActionResult Index()
        {
            var data = GetCustomersData().AsQueryable();
            return View(data);
        }

        public IActionResult Privacy()
        {
            return View();
        }

        public List<Customer> GetCustomersData()
        {
            string[] Customers = { "Paul Henriot", "Karin Josephs", "Mario Pontes", "Mary Saveley" };
            int[] CountryID = { 3, 2, 3, 1 };
            string[] PhoneNumbers = { "(+33) 23 67 22 20", "(+49) 23 67 22 20", "(+55) 23 67 22 20", "(+32) 23 67 22 20" };
            DateTime[] Birthdates = { new System.DateTime(2020, 12, 05, 17, 25, 6) , new System.DateTime(2021, 10, 09, 12, 25, 6) ,
                new System.DateTime(2005, 02, 05, 07, 25, 6) , new System.DateTime(2015, 08, 15, 05, 35, 6) };
            
            List<Customer> CustomersList = new List<Customer> { };
            for (int i = 0; i < Customers.Length; i++)
            {
                CustomersList.Add(new Customer
                {
                    CustomerID = i,
                    Name = Customers[i],
                    CountryID = CountryID[i],
                    Phone = PhoneNumbers[i],
                    Birthdate = Birthdates[i]
                });
            }
            return CustomersList;
        }

        
        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}
